
from odoo.upgrade import util

def remove_xmlid(cr, xmlid):
    module, _sep, name = xmlid.partition(".")
    cr.execute("DELETE FROM ir_model_data WHERE module = %s AND name = %s", (module, name))

def remove_icp(cr, icp_key):
    cr.execute("DELETE FROM ir_config_parameter WHERE key = %s", (icp_key,))

def migrate(cr, version):
    # remove custom referral modules
    # but keep utm.{campaign,tag} and referral.tracking datas
    remove_xmlid(cr, "website_sale_referral.utm_campaign_tag_referral")
    remove_xmlid(cr, "website_sale_referral.utm_campaign_referral")
    remove_icp(cr, "website_sale_referral.redirect_page")
    remove_icp(cr, "website_sale_referral.twitter_message")
    cr.execute(
        "SELECT id FROM mail_activity WHERE activity_type_id = %s",
        (util.ref(cr, "website_sale_referral.mail_act_data_referral_reward"),)
    )
    util.remove_records(cr, "mail.activity", [rid for rid, in cr.fetchall()])
    util.remove_model(cr, "referral.tracking", drop_table=False)
    util.remove_module(cr, "odoo_referral_internal")
    util.remove_module(cr, "website_crm_referral")
    util.remove_module(cr, "website_sale_referral")

    # uninstall "mrp" and upstream dependencies
    util.uninstall_module(cr, "spreadsheet_dashboard_mrp_account")
    util.uninstall_module(cr, "mrp_accountant")
    util.uninstall_module(cr, "mrp_account_enterprise")
    util.uninstall_module(cr, "project_mrp")
    util.uninstall_module(cr, "mrp_account")
    util.uninstall_module(cr, "purchase_mrp")
    util.uninstall_module(cr, "sale_mrp")
    util.uninstall_module(cr, "mrp")
